%define anolis_release 3
%global enginesdir %(pkg-config --variable=enginesdir libcrypto)
%global githubname QAT_Engine

Name:           qatengine
Version:        1.7.0
Release:        %{anolis_release}%{?dist}
Summary:        Intel® QuickAssist Technology OpenSSL* Engine(QAT_Engine)
License:        BSD-3-Clause AND OpenSSL
URL:            https://github.com/intel/%{githubname}
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

Patch1000:      1000-add-amd-CPU-for-qat_sw.patch

ExclusiveArch:  x86_64

BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  gcc
BuildRequires:  libtool
BuildRequires:  openssl-devel >= 3.0.0
BuildRequires:  qatlib-devel >= 23.02.0
BuildRequires:  intel-ipp-crypto-mb-devel >= 1.0.6
BuildRequires:  intel-ipsec-mb-devel >= 1.3.0
BuildRequires:  openssl

Requires:  intel-ipsec-mb
Requires:  intel-ipp-crypto-mb
Requires:  openssl zlib pcre2

%description
The %{name} provides the Intel QuickAssist Technology OpenSSL Engine (an
OpenSSL Plug-In Engine). Intel® QuickAssist Technology OpenSSL* Engine
(QAT_Engine) supports acceleration for both hardware as well as optimized
software based on vectorized instructions. This change starting with the
3rd Generation Intel® Xeon® Scalable Processors family provides users more
options to accelerate their workloads. The QAT OpenSSL* engine now supports
the ability to accelerate from the stand OpenSSL* to basic Intel instruction
set, to either Hardware acceleration path (via the qat_hw path) or via the
optimized SW path (qat_sw lib). 

%prep
%autosetup -n QAT_Engine-%{version}

%build
autoreconf -ivf
%configure --enable-qat_sw
%make_build

%install
%make_install

find %{buildroot} -name "*.la" -delete

%check
export OPENSSL_ENGINES=%{buildroot}%{enginesdir}

%files
%license LICENSE*
%doc README.md docs*
%{enginesdir}/%{name}.so

%changelog
* Wed Dec 04 2024 Zelin Deng <zelin.deng@linux.alibaba.com> - 1.7.0
- Update package to 1.7.0

* Tue Jul 23 2024 Guanjun <guanjun@linux.alibaba.com> - 1.2.0-3
- Override the pkg-config settings and forcibly utilize OpenSSL 3.x versions during the compilation process

* Wed May 22 2024 Guanjun <guanjun@linux.alibaba.com> - 1.2.0-2
- Add amd CPU for qat_sw

* Wed Aug 16 2023 Guanjun <guanjun@linux.alibaba.com> - 1.2.0-1
- Add build requires intel-QAT20-devel
- enable qat_hw and qat_sw

* Sat Apr 15 2023 Jing Zhang <renyu.zj@linux.alibaba.com> - 0.6.16-4
- Refact spec

* Tue Oct 25 2022 happy_orange <songnannan@linux.alibaba.com> - 0.6.16-3
- enable qat_sw and disable qat_hw

* Tue Oct 18 2022 happy_orange <songnannan@linux.alibaba.com> - 0.6.16-2
- delete scripts of la and change abi.

* Thu Oct 13 2022 happy_orange <songnannan@linux.alibaba.com> - 0.6.16-1
- Init package from upstream
